import java.util.*;
import java.util.logging.*;

// unfolded

public class ASTCall extends ASTNode {
    String chr;
    String chi;
    ASTType type;
    ASTNode rhs;

    public ASTCall(String _chr,String _chi,ASTType _type,ASTNode _rhs) {
	chr = _chr;
	chi = _chi;
	type = _type;
	rhs = _rhs;
    }

	public  void ASTInsertUse(String _ch, ASTNode here, Boolean disCont) throws Exception
	{
		if(_ch.equals(chi)) {
			ASTNode pushUse = new ASTUse(_ch, here);
			pushUse.eg = eg;
			here.setanc(pushUse);
			pushUse.setanc(this);
			rhs = pushUse;
		}else
			anc.ASTInsertUse(_ch, this, disCont);
	}

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
		ASTNode pushCall = new ASTCall(ch, cho, t,here);
		pushCall.eg = eg;
		here.setanc(pushCall);
		pushCall.setanc(this);
		rhs = pushCall;
	}

    public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
	{
		if(_ch.equals(chi)) {
			ASTNode pushWhy = new ASTWhy(_ch, here);
			pushWhy.eg = eg;
			here.setanc(pushWhy);
			pushWhy.setanc(this);
			rhs = pushWhy;
			eg.insert(_ch, _t);
		} else
			anc.ASTInsertWhyNot(_ch, _t, this);
	}

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		rhs = newCont;
	}

    public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	if(_ch.equals(chi))
	    throw new TypeError("for " + _ch + " type pending after CALL on "+chr);
	rhs = rhs.ASTweakeningOnLeaf(_ch,exp);
	return this;
    }

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
		this.eg = eg;

		ASTType ty;
		try {
			ty = eg.find(chr);
			ty = ty.unfoldType(ep);
		} catch(Exception e){
			this.inferUses(chr,ed,ep);

			// System.out.println("Look on ed "+chr);
			ty = ed.find(chr);
			// System.out.println("found on ed "+chr);
			ty = ty.unfoldType(ep);

			if(ty instanceof ASTWhyT){
				ASTWhyT t = (ASTWhyT) ty;
				ty = t.getin();;
				this.getanc().ASTInsertWhyNot(chr, ty, this);
				// eg.crawl();
				ed.updmove(chr);
			}else
				throw  new TypeError("CALL: "+chr+" is neither unrestricted nor does it type linearly with ?" +
						      		"but with " + ty.toStr(ep));
		}


		// System.out.println("TC CALL unfolded ty "+ty.unfoldType(ep).toStr(ep)+ " go to unf "+type);

	ASTType typee = (type==null)?null:type.unfoldType(ep);	;
	
	// System.out.println("TC CALL equalst "+typee+" "+ty);

	if(typee!=null && !typee.equalst(ty,ep,true,new Trail()))
	    throw  new TypeError("CALL "+chr+" type mismatch: declared="+typee.toStr(ep)+" found="+ty.toStr(ep));

	ed=ed.assoc(chi,ty);
	rhs.typecheck(ed,eg,ep);
	rhs.linclose(ed,ep);
	rhs.linclose(chi,ed,ep);


    }

    public Set<String> fn(Set<String> s) {
	s=rhs.fn(s);
	s.remove(chi);
	s.add(chr);
	return s;
    }

	public Set<String> fnLinear(Set<String> s) {
		s=rhs.fnLinear(s);
		s.remove(chi);
		return s;
	}

    public ASTNode subst(Env<ASTType> e) {
	ASTType ts = (type==null)?null:type.subst(e);
	    ASTCall p = new ASTCall (chr,chi,ts,rhs.subst(e));
	    p.rhs.setanc(p);
	    return p;
	}

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		if(y == chr) {
			chr = x;
			rhs.subs(x,y);
		}
		else if(x == chi){//we rename the bound name chi to fresh to avoid capturing name x
			String fresh = ASTNode.gensym();
			rhs.subs(fresh, chi);
			chi = fresh;
			rhs.subs(x,y);
		}
		else if(y != chi)
			rhs.subs(x,y);
	}

	public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
		Server server = eg.find(chr);
		LinSession session = (LinSession) server.call(chi);
		logger.info("CALL server " + server.chi + " on session " + session.getId());
		rhs.runproc(ep, ed.assoc(chi, session), eg, logger);

	}
}
