import java.util.*;
import java.util.logging.*;

// unfolded

public class ASTCell extends ASTNode {
    String ch;
    String chc;
    ASTType type;
    ASTNode rhs;
    boolean linear;

    public ASTCell (String _chr,String _chc,ASTType _type,ASTNode _rhs) {
	ch = _chr;
	chc = _chc;
	type = _type;
	rhs = _rhs;
    }

	public  void ASTInsertUse(String _ch, ASTNode here, Boolean disCont) throws Exception
	{
		if(_ch.equals(chc)) {
			ASTNode pushUse = new ASTUse(_ch, here);
			pushUse.eg = eg;
			here.setanc(pushUse);
			pushUse.setanc(this);
			rhs = pushUse;
		}else
			anc.ASTInsertUse(_ch, this, disCont);
	}

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
		ASTNode pushCall = new ASTCall(ch, cho, t,here);
		pushCall.eg = eg;
		here.setanc(pushCall);
		pushCall.setanc(this);
		rhs = pushCall;
	}

	public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
	{
		if(_ch.equals(chc)) {
			ASTNode pushWhy = new ASTWhy(_ch, here);
			pushWhy.eg = eg;
			here.setanc(pushWhy);
			pushWhy.setanc(this);
			rhs = pushWhy;
			eg.insert(_ch, _t);
		} else
			anc.ASTInsertWhyNot(_ch, _t, this);
	}

    public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	if(_ch.equals(chc)) { // may place before cell
	    if (!_ch.equals(ch)) {
		return this.ASTweakeningHere(_ch,exp);
	    }
	    throw new TypeError("for " + _ch + " type pending in CELL on "+chc);
	}
	rhs = rhs.ASTweakeningOnLeaf(_ch,exp);
	return this;
    }

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		rhs = newCont;
	}

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
		this.eg = eg;

		this.inferUses(ch,ed,ep);

		ASTType ty = ed.find(ch);
		ASTType typeex = null;
		    
		ty = ty.unfoldType(ep);
		ty = ASTType.unfoldRec(ty);

		if (type!=null) {
		    typeex = type.unfoldType(ep);
		    typeex = ASTType.unfoldRec(typeex);;
		}
		
		if (ty instanceof ASTCellT) {
			ASTCellT tyr = (ASTCellT)ty;
			ASTType payl2 = tyr.t.unfoldType(ep);
			payl2 = ASTType.unfoldRec(payl2);
			ASTType payl = new ASTAffineT(payl2);
			    
			ed.upd(ch,null);
			
			if(typeex != null && !typeex.equalst(payl,ep,true,new Trail())) {
				throw new TypeError("CELL "+chc+" type mismatch; found="+payl.toStr(ep)+" expected="+typeex.toStr(ep));
			}
			    
			ed = ed.assoc(chc, (payl));
			
			if(rhs instanceof ASTExpr){
				        ASTExpr pe = (ASTExpr)rhs;
				        try{
							ASTNode rhsc = compileExpr(chc,pe,payl2,ep);
							rhs = new ASTAffine(chc, rhsc);
							rhsc.setanc(rhs);
						} catch (Exception ee){
						if(pe instanceof ASTVId){
							String x = ((ASTVId) pe).ch;

							try{//checks if free name is linear or unrestricted
								ed.find(x);
								rhs = new ASTFwd(chc, x);
							}catch (Exception e){
								ASTFwdB f = new ASTFwdB(chc, x);
								rhs = new ASTAffine(chc, f);
								f.setanc(rhs);
							}
						}else
							throw new TypeError("CELL " + ch + ": cannot be parsed as cell of basic expression nor as free cell.");
				        }
				}
			rhs.setanc(this);
			
			rhs.typecheck(ed,eg,ep);
			rhs.linclose(ed,ep);
			rhs.linclose(chc,ed,ep);
		       	linear = true;
		 
		} else if (ty instanceof ASTCellBT){
			ASTCellBT tyr = (ASTCellBT)ty;
			ASTType payl = tyr.t.unfoldType(ep);
			ed.upd(ch,null);
			payl = new ASTBangT(payl);
			if(typeex != null && typeex.equalst(payl,ep,true,new Trail())) {
				ed = ed.assoc(chc, (payl));
				rhs.typecheck(ed,eg,ep);
				rhs.linclose(ed,ep);
				rhs.linclose(chc,ed,ep);
				linear = false;
			} else if (typeex!=null)
				throw new TypeError("CELL "+chc+" type mismatch; found="+payl.toStr(ep)+" expected="+typeex.toStr(ep));
		}
		else throw new TypeError("CELL: "+ch+" is neither of STATE nor of STATE! type.");
	}


	public Set<String> fn(Set<String> s) {
		s.add(ch);
		s = rhs.fn(s);
		s.remove(chc);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s.add(ch);
		s = rhs.fnLinear(s);
		s.remove(chc);
		return s;
	}

    public ASTNode subst(Env<ASTType> e) {
	ASTType ts = type==null?null:type.subst(e);
	    ASTCell p = new ASTCell (ch,chc,ts,rhs.subst(e));
	    p.rhs.setanc(p);
	    return p;
	}

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		if(y == ch)
			ch = x;
		else if(x == chc){//we rename the bound name chs to fresh to avoid capturing name x
			String fresh = ASTNode.gensym();
			rhs.subs(fresh, chc);
			chc = fresh;
			rhs.subs(x,y);
		}
		else if(y != chc)
			rhs.subs(x,y);
	}

    public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
    	Cell cell = (Cell) ed.find(ch);
    	cell.setCell(chc, rhs,ep, ed, eg, logger,linear);
	}

}
