import java.util.*;
import java.util.logging.*;

// unfolded

public class ASTCoClose extends ASTNode{
    String ch;
    ASTNode rhs;


    public ASTCoClose(String _ch, ASTNode _rhs) {
	ch = _ch;
	rhs = _rhs;
	}

    public  void ASTInsertUse(String _ch, ASTNode here, Boolean disCont) throws Exception
    {
		anc.ASTInsertUse(_ch,this, disCont);
    }

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
		ASTNode pushCall = new ASTCall(ch, cho, t,here);
		pushCall.eg = eg;
		here.setanc(pushCall);
		pushCall.setanc(this);
		rhs = pushCall;
	}

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
    	rhs = newCont;
	}


	public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	    rhs = rhs.ASTweakeningOnLeaf(_ch,exp);
	    // System.out.println("coclose rhs "+rhs);
	    return this;
    }

    public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
	{
		anc.ASTInsertWhyNot(_ch, _t, this);
	}

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
		this.eg = eg;
		this.inferUses(ch,ed,ep);

		ASTType ty = ed.find(ch);
	    ty = ty.unfoldType(ep);
	    if (ty instanceof ASTBotT) {
	       	ed.upd(ch,null); 
		rhs.typecheck(ed,eg,ep);
	    } else throw new TypeError("WAIT: "+ch+" is not of WAIT type.");
    }

	public Set<String> fn(Set<String> s) {
		s.add(ch);
		s = rhs.fn(s);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s.add(ch);
		s = rhs.fnLinear(s);
		return s;
	}

        public ASTNode subst(Env<ASTType> e) {	    
	    ASTCoClose p = new ASTCoClose(ch,rhs.subst(e));
	    p.rhs.setanc(p);
	    return p;
	}

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		if(y == ch)
			ch = x;
		else
			rhs.subs(x,y);
	}

	public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
		//CLLSj.logger.info("COCLOSE starts.");
		Channel channel = (Channel) ed.find(ch);
		//CLLSj.logger.info("COCLOSE: found channel. ");
		//System.out.println("[RunStatus] WAIT on "+ch+" start.");
		channel.receive();
		//CLLSj.logger.info("COCLOSE: took message.");
		//System.out.println("[RunStatus] WAIT on "+session.id+" end.");
		//se.remove(ch);
		rhs.runproc(ep, ed, eg, logger);
	}

    	public void show()  {
	    System.out.println(this+" "+anc);
	    rhs.show();
	}

}
