import java.util.*;
import java.util.logging.*;

// unfolded

public class ASTCut extends ASTNode {
    String id;
    ASTType type;
    ASTNode lhs;
    ASTNode rhs;

    public ASTCut(String _id,ASTType _type,ASTNode _lhs,ASTNode _rhs) {
	id = _id;
	type = _type;
	lhs = _lhs;
	rhs = _rhs;
	}

        public void show() {
	    System.out.println("CUT LHS "+this);
	    lhs.show();
	    System.out.println("CUT RHS "+this);
	    rhs.show();
	}

    public ASTNode ASTweakeningOnLeaf(String ch, boolean exp) throws Exception
    {
	if(ch.equals(id)) {
	    return this.ASTweakeningHere(ch,exp);
	}
	else {   
	    Set<String> s = lhs.fn(new HashSet<String>());
	    if ( s.contains(ch)  ) {
		lhs = lhs.ASTweakeningOnLeaf(ch,exp);
		return this;
	    };
	    rhs = rhs.ASTweakeningOnLeaf(ch,exp);
	    return this;
	}
    }

    public  void ASTInsertUse(String _ch, ASTNode here, Boolean disCont) throws Exception
    {
    	if(_ch.equals(id)) {
			ASTNode pushUse = new ASTUse(_ch, here);
			pushUse.eg = eg;

			here.setanc(pushUse);
			pushUse.setanc(this);
			if (lhs == here) {
				lhs = pushUse;
			} else {
				rhs = pushUse;
			}
		} else
			anc.ASTInsertUse(_ch,this,disCont);
   }

	public  void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception
	{
		ASTNode pushCall = new ASTCall(ch, cho, t, here);
		pushCall.eg = eg;

		here.setanc(pushCall);
		pushCall.setanc(this);
		if (lhs==here) {
			lhs = pushCall;
		}
		else {	rhs = pushCall;
		}
	}


	public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
	{

		if(_ch.equals(id)) {
			ASTNode pushWhy = new ASTWhy(_ch, here);
			pushWhy.eg = eg;
			here.setanc(pushWhy);
			pushWhy.setanc(this);
			eg.insert(_ch, _t);
			if(lhs == here) {
				lhs = pushWhy;
			}
				else {
				rhs = pushWhy;
				}
		} else
			anc.ASTInsertWhyNot(_ch, _t, this);
	}

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		if(caller == lhs)
			lhs = newCont;
		else
			rhs = newCont;
	}


	public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
		this.eg = eg;

	ASTType cutty = type.unfoldType(ep);
		
	Env<ASTType> el = ed.assoc(id,cutty.dual(ep));
	Env<ASTType> er = ed.assoc(id,cutty);
	Env<ASTType> eglhs = eg.assoc("$DUMMY",new ASTBotT());

	lhs.typecheck(el,eglhs,ep);
	lhs.linclose(el,ep);

	lhs = ASTInferLinClose(lhs,id,el,ep);
		Env<ASTType> egrhs = eg.assoc("$DUMMY",new ASTBotT());
       	rhs.typecheck(er, egrhs, ep);
	
       	rhs.linclose(er,ep);

	rhs = ASTInferLinClose(rhs,id,er,ep);
	
        } 

	public Set<String> fn(Set<String> s) {
		s = lhs.fn(s);
		s = rhs.fn(s);
		s.remove(id);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s = lhs.fnLinear(s);
		s = rhs.fnLinear(s);
		s.remove(id);
		return s;
	}

        public ASTNode subst(Env<ASTType> e) {
	    ASTCut p = new ASTCut(id,type.subst(e),lhs.subst(e), rhs.subst(e));
	    p.lhs.setanc(p);
	    p.rhs.setanc(p);
	    return p;
    }

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		 if(x == id){
			String fresh = ASTNode.gensym();
			rhs.subs(fresh, id);
			lhs.subs(fresh, id);
			id = fresh;
			rhs.subs(x,y);
			lhs.subs(x,y);
		}
		else if(y != id)
			rhs.subs(x,y);
			lhs.subs(x,y);
	}
	/*
		Calls runproc on lhs and rhs in parallel with session_directory = session_directory, id -> new Session(id)
	 */
	public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
		LinSession session = new LinSession(id);
		Env<LinSession> edCut = ed.assoc(id,session);

		
		CLLSj.threadPool.submit( new Runnable(){
			public void run(){ try {
				lhs.runproc(ep, edCut, eg, logger);
			} catch (Exception e) {e.printStackTrace(System.out);} }
		});
		
		CLLSj.threadPool.submit( new Runnable(){
			public void run(){ try {
				rhs.runproc(ep, edCut, eg, logger);
			} catch (Exception e) {e.printStackTrace(System.out);} }
		});

	}

	public String toStr(Env<EnvEntry> ep) throws Exception{
		return "cut {\n\t" + lhs.toStr(ep) + "\n\t|" + id + "|\n\t" + rhs.toStr(ep) + "\n}";
	}
}






