import java.util.*;
import java.util.logging.*;

public class ASTIf extends ASTNode {

    ASTExpr expr;
    ASTNode thenp;
    ASTNode elsep;

    public ASTIf(ASTExpr _expr,ASTNode _thenp, ASTNode _elsep) {
	expr = _expr;
	thenp = _thenp;
	elsep = _elsep;
	}

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		if(caller == expr)
			expr = (ASTExpr) newCont;
		else if (caller == thenp)
			thenp = newCont;
		else
			elsep = newCont;
	}

    public void ASTInsertUse(String _ch, ASTNode here, Boolean disCont) throws Exception
    {
		if (expr==here) {
			anc.ASTInsertUse(_ch, this, disCont);
			System.out.println("Infeering use 2 in " + _ch);

		}
		else {
			ASTNode pushUse = new ASTUse(_ch,here);
			pushUse.eg = eg;
			here.setanc(pushUse);
			pushUse.setanc(this);
			if (thenp==here) thenp = pushUse;
			else elsep = pushUse;
			System.out.println("Infeering use in " + _ch);
		}
    }

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception
	{
		if (expr==here) anc.ASTInsertCall(ch, cho, t, this); // in expr, push up !
		else {
			ASTNode pushCall = new ASTCall(ch, cho,t, here);
			pushCall.eg = eg;

			here.setanc(pushCall);
			pushCall.setanc(this);
			if (thenp==here) thenp = pushCall;
			else elsep = pushCall;
		}
	}

	public void ASTInsertWhyNot(String ch, ASTType _t, ASTNode here) throws Exception
	{
		anc.ASTInsertWhyNot(ch, _t, this);
	}
   
public ASTNode ASTweakeningOnLeaf(String ch, boolean exp) throws Exception
    {
    thenp = thenp.ASTweakeningOnLeaf(ch,exp);
    elsep = elsep.ASTweakeningOnLeaf(ch,exp);
    return this;
    }
	public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
		this.eg = eg;
		ASTType et;
		boolean lin;

		try {
			lin = true;
			et =expr.etypecheck(ed,eg,ep,lin);
		} catch (Exception ee) {
			ee.printStackTrace(System.out);
			lin = false;
			et =expr.etypecheck(ed,eg,ep,lin);
		};

		//	Env<ASTType> egb = eg.dupe();

		Env<ASTType> egb = eg.assoc("$DUM", new ASTBotT());

		//	egb.crawl();

		if (et instanceof ASTCoLboolT) {
		    
			Env<ASTType> eb = ed.dup();
						
			thenp.typecheck(ed,egb,ep);

			//	egb.crawl();

			ed.updmove(eb); // correction for inference

			this.linclose(ed,ep);

			egb = eg.assoc("$DUM", new ASTBotT());
		      			
			elsep.typecheck(eb,egb,ep);

			//	egb.crawl();
			
			this.linclose(eb,ep);
						
			if (!eb.eq(ed))
				throw new TypeError("IF : unmatched then and else linear contexts");
		} else
			throw new TypeError("IF : condition not of linear boolean type");
	}

	public Set<String> fn(Set<String> s) {
		s = expr.fn(s);
		s = thenp.fn(s);
		s = elsep.fn(s);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s = expr.fnLinear(s);
		s = thenp.fnLinear(s);
		s = elsep.fnLinear(s);
		return s;
	}

        public ASTNode subst(Env<ASTType> e) {
	    ASTIf p = new ASTIf(expr, thenp.subst(e), elsep.subst(e));
	    p.thenp.setanc(p);
	    p.elsep.setanc(p);
	    p.expr.setanc(p);
	    return p;
	}

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		expr.subs(x,y);
		thenp.subs(x,y);
		elsep.subs(x,y);
	}
    
    public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
    	VBool v = (VBool) expr.eval(ed, eg);
    	if(v.get())
    		thenp.runproc(ep, ed, eg, logger);
    	else
    		elsep.runproc(ep,ed,eg, logger);
    }

}
