import java.util.*;
import java.util.logging.*;

public class ASTMix extends ASTNode {

ASTNode lhs;
ASTNode rhs;

	public ASTMix(ASTNode _lhs,ASTNode _rhs) {
		lhs = _lhs;
		rhs = _rhs;
	}

    public  void ASTInsertUse(String ch, ASTNode here, Boolean disCont) throws Exception
    {
		anc.ASTInsertUse(ch,this,disCont);
    }

	public  void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception
	{
		ASTNode pushCall = new ASTCall(ch, cho, t, here);
		pushCall.eg = eg;

		here.setanc(pushCall);
		pushCall.setanc(this);
		if (lhs==here) {
			lhs = pushCall;
		}
		else {	rhs = pushCall;
		}
	}

	public void ASTInsertWhyNot(String ch, ASTType _t, ASTNode here) throws Exception
	{
		anc.ASTInsertWhyNot(ch, _t, this);
	}

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		if(caller == lhs)
			lhs = newCont;
		else
			rhs = newCont;
	}

    public ASTNode ASTweakeningOnLeaf(String ch, boolean exp) throws Exception
    {
	    Set<String> s = lhs.fn(new HashSet<String>());
	    if ( s.contains(ch)  ) {
		lhs = lhs.ASTweakeningOnLeaf(ch,exp);
		return this;
	    };
	    rhs = rhs.ASTweakeningOnLeaf(ch,exp);
	    return this;
    }

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
		this.eg = eg;
		Env<ASTType> eglhs = eg.assoc("$DUMMY",new ASTBotT());
		lhs.typecheck(ed,eglhs,ep);
		lhs.linclose(ed,ep);
		Env<ASTType> egrhs = eg.assoc("$DUMMY",new ASTBotT());
		rhs.typecheck(ed,egrhs,ep);
		rhs.linclose(ed,ep);
    }

	public Set<String> fn(Set<String> s) {
		s = lhs.fn(s);
		s = rhs.fn(s);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s = lhs.fnLinear(s);
		s = rhs.fnLinear(s);
		return s;
	}

        public ASTNode subst(Env<ASTType> e) {
	    ASTMix p = new ASTMix(lhs.subst(e), rhs.subst(e));
	    p.lhs.setanc(p);
	    p.rhs.setanc(p);
	    return p;
	}

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		lhs.subs(x,y);
		rhs.subs(x,y);
	}

    /*
    	Calls runproc on lhs and rhs in parallel
     */
	public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
		CLLSj.threadPool.submit(
				new Runnable(){
					public void run(){ try {
						lhs.runproc(ep, ed, eg, logger);
					} catch (Exception e) {e.printStackTrace(System.out);} }
				});
		CLLSj.threadPool.submit(
				new Runnable(){
					public void run(){ try {
						rhs.runproc(ep, ed, eg, logger);
					} catch (Exception e) {e.printStackTrace(System.out);} }
				});

	}
}
