import java.util.*;
import java.util.logging.*;

public class ASTPrintLn extends ASTNode {

    ASTExpr expr;
    ASTNode rhs;
    boolean nl;

    public ASTPrintLn(ASTExpr _expr,ASTNode _rhs, boolean _nl) {
	expr = _expr;
	rhs = _rhs;
	nl = _nl;
	}

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		if(caller == expr)
			expr = (ASTExpr) newCont;
		else
			rhs = newCont;
	}

    public void ASTInsertUse(String ch, ASTNode here, Boolean disCont) throws Exception
    {
	anc.ASTInsertUse(ch,this, disCont); // insert above up
    }

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception
	{
		anc.ASTInsertCall(ch, cho, t, this); // insert above up
	}

	public void ASTInsertWhyNot(String ch, ASTType _t, ASTNode here) throws Exception
	{
		anc.ASTInsertWhyNot(ch, _t, this);
	}

    public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	    rhs = rhs.ASTweakeningOnLeaf(_ch,exp);
	    return this;
    }

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
 	ASTType et;

	try {
	    et =expr.etypecheck(ed,eg,ep,false);
	} catch (Exception ee) {
		et = expr.etypecheck(ed,eg,ep,true);
	    };
	if (!(et instanceof ASTCoLBasicType ))
		    throw new TypeError("PRINT : argument not of Co LBasicType");
	rhs.typecheck(ed,eg,ep);
   }

	public Set<String> fn(Set<String> s) {
		s = rhs.fn(s);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s = rhs.fnLinear(s);
		return s;
	}

    public ASTNode subst(Env<ASTType> e) {
	ASTPrintLn p= new ASTPrintLn(expr,rhs.subst(e),nl);
	p.rhs.setanc(p);
	p.expr.setanc(p);
	return p;
	}

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		expr.subs(x,y);
		rhs.subs(x,y);
	}

    public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
    	Value v = expr.eval(ed,eg);
    	if(nl)
    		System.out.println(v.toStr());
    	else
    		System.out.print(v.toStr());
	System.out.flush();
		rhs.runproc(ep, ed, eg, logger);
    }

	public String toStr(Env<EnvEntry> ep) throws Exception {
    	String str = nl? "println (" : "print (";
    	return str + expr.toStr(ep) + ");\n" + rhs.toStr(ep);
	}

    	public void show()  {
	    System.out.println(this+" "+anc);
	    rhs.show();
	}

}
