import java.util.*;
import java.util.logging.*;

public class ASTPromoCoExpr extends ASTNode {

    String ch;
    ASTExpr expr;

    public ASTPromoCoExpr(String _ch, ASTExpr _expr) {
	expr = _expr;
	ch = _ch; 
    }

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		expr = (ASTExpr) newCont;
	}

    public void ASTInsertUse(String ch, ASTNode here, Boolean disCont) throws Exception
    {
		anc.ASTInsertUse(ch,this, disCont); // insert above up
    }

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception
	{
		anc.ASTInsertCall(ch, cho, t, this); // insert above up
	}

    public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
    {
		anc.ASTInsertWhyNot(_ch, _t, this);
    }

    public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	return this.ASTweakeningTerm(_ch,exp);		
    }

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
		this.inferUses(ch,ed,ep);
		ASTType bt = expr.etypecheck(ed,eg,ep,false);

	ASTType idt = ed.find(ch);
	if (idt instanceof ASTBangT) {
	    ASTType idtb = ((ASTBangT)idt).getin();
	    if (idtb instanceof ASTBasicType) {
		if (!bt.equalst(idtb.dual(ep),ep, true, new Trail()))
		    throw new TypeError("LET "+ch+" type mismatch; found="+bt.toStr(ep)+" expected="+idt.toStr(ep));
		ed.upd(ch,null);
	    } else throw new TypeError("LET "+ch+" not of !-basic type");
	} else throw new TypeError("LET "+ch+" not of basic type");
    }

	public Set<String> fn(Set<String> s) {
		s=expr.fn(s);
		s.add(ch);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s=expr.fnLinear(s);
		s.add(ch);
		return s;
	}

        public ASTNode subst(Env<ASTType> e) {
	    return this;
	}

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		if(y == ch)
			ch = x;
		else
			expr.subs(x,y);
	}
    public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
    	Value v = expr.eval(null, eg);
    	Channel channel = (Channel) ed.find(ch);
    	channel.send(v);
    }

}
