import java.util.*;
import java.util.logging.*;

public class ASTRecv extends ASTNode {
    String chr;
    String chi;
    ASTType type;
    ASTNode rhs;

    public ASTRecv(String _chr,String _chi,ASTType _type,ASTNode _rhs) {
	chr = _chr;
	chi = _chi;
	type = _type;
	rhs = _rhs;
    }

	public  void ASTInsertUse(String _ch, ASTNode here, Boolean disCont) throws Exception
	{
		if(_ch.equals(chr) || _ch.equals(chi)) {
			ASTNode pushUse = new ASTUse(_ch, here);
			pushUse.eg = eg;
			here.setanc(pushUse);
			pushUse.setanc(this);
			rhs = pushUse;
		}else
			anc.ASTInsertUse(_ch, this, disCont);
	}

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		rhs = newCont;
	}

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
		ASTNode pushCall = new ASTCall(ch, cho, t,here);
		pushCall.eg = eg;
		here.setanc(pushCall);
		pushCall.setanc(this);
		rhs = pushCall;
	}
    
    public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	if(_ch.equals(chi)) {
	    if (!_ch.equals(chr)) { // may place here before receeive
		return this.ASTweakeningHere(_ch,exp);
	    }
	    throw new TypeError("for " + _ch + " type pending after RECV on "+chr);
	}
	rhs = rhs.ASTweakeningOnLeaf(_ch,exp);
	return this;
    }

	public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
	{
		if(_ch.equals(chr) || _ch.equals(chi)) {
			ASTNode pushWhy = new ASTWhy(_ch, here);
			here.setanc(pushWhy);
			pushWhy.setanc(this);
			rhs = pushWhy;
			eg.insert(_ch, _t);
		} else
			anc.ASTInsertWhyNot(_ch, _t, this);
	}

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
		this.eg = eg;

		this.inferUses(chr,ed,ep);

		ASTType typee = null;
	// System.out.println("\nRECV !!!");

	ASTType ty = ed.find(chr);
	if (type != null) {
	typee = type.unfoldType(ep);
	typee = ASTType.unfoldRec(typee);
	};
	// System.out.println("RECV types ty of channel ="+ty.toStr(ep)+"\ndeclared type of payload="+typee.toStr(ep));
	    ty = ty.unfoldType(ep);
	    ty = ASTType.unfoldRec(ty);
	    if (ty instanceof ASTRecvT) {
		ASTRecvT tyr = (ASTRecvT)ty;
		// System.out.println("RECV "+chi+" types found="+tyr.getlhs().toStr(ep)+" declared="+typee.toStr(ep));		
		ty = tyr.getlhs().unfoldType(ep);
		ty = ASTType.unfoldRec(ty);
	       	// System.out.println("RECV declared type of payload unfolded="+ty.toStr(ep));
		if(typee != null && !typee.equalst(ty,ep,true,new Trail()))
		    throw new TypeError("RECV "+chi+" type mismatch; found="+tyr.getlhs().toStr(ep)+" declared="+typee.toStr(ep));
		// System.out.println("\nRECV XXX !!!");
		ed.upd(chr,tyr.getrhs().unfoldType(ep));
		Env<ASTType> ext = ed.assoc(chi, ty);
		ep = ASTNode.propagateRVar(ep, chr, chi);
		rhs.typecheck(ext,eg,ep);
		rhs.linclose(ed,ep);
		
		rhs = ASTInferLinClose(rhs,chi,ext,ep);
				
		
	    } else throw new TypeError("RECV "+chr+" is not of RECV type.");
    }

	public Set<String> fn(Set<String> s) {
		s.add(chr);
		s = rhs.fn(s);
		s.remove(chi);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s.add(chr);
		s = rhs.fnLinear(s);
		s.remove(chi);
		return s;
	}

    public ASTNode subst(Env<ASTType> e) {
	ASTRecv p;
	if (type == null) 
		p= new ASTRecv(chr,chi,type,rhs.subst(e));
	else
		p= new ASTRecv(chr,chi,type.subst(e),rhs.subst(e));
	p.rhs.setanc(p);
	return p;
	}

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		if(y == chr) {
			chr = x;
			rhs.subs(x,y);
		}
		else if(x == chi){ //we rename the bound name chi to fresh to avoid capturing name x
			String fresh = ASTNode.gensym();
			rhs.subs(fresh, chi);
			chi = fresh;
			rhs.subs(x,y);
		}
		else if(y != chi)
			rhs.subs(x,y);
	}

	public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
		Channel channel = (Channel) ed.find(chr);
		//System.out.println("[RunStatus] RECV on "+session.id+" start.");

		LinSession session_in = (LinSession) channel.receive();

		//System.out.println("[RunStatus] RECV on "+session.id+" end.");
		rhs.runproc(ep,ed.assoc(chi, session_in), eg, logger);
	}

}
