import java.util.*;
import java.util.logging.*;

public class ASTRecvTy extends ASTNode {
    
    String chs;
    String tyid;
    String tyidGen;
    ASTNode rhs;

    public ASTRecvTy( String _chs, String _tyid, ASTNode _rhs )
    {
	chs = _chs;
	tyid = _tyid;
	rhs = _rhs;
    }

	public  void ASTInsertUse(String _ch, ASTNode here, Boolean disCont) throws Exception
	{
		if(_ch.equals(chs)) {
			ASTNode pushUse = new ASTUse(_ch, here);
			pushUse.eg = eg;
			here.setanc(pushUse);
			pushUse.setanc(this);
			rhs = pushUse;
		}else
			anc.ASTInsertUse(_ch, this, disCont);
	}

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
		ASTNode pushCall = new ASTCall(ch, cho, t,here);
		pushCall.eg = eg;
		here.setanc(pushCall);
		pushCall.setanc(this);
		rhs = pushCall;
	}

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		rhs = newCont;
	}

	public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
	{
		if(_ch.equals(chs)) {
			ASTNode pushWhy = new ASTWhy(_ch, here);
			here.setanc(pushWhy);
			pushWhy.setanc(this);
			rhs = pushWhy;
			eg.insert(_ch, _t);
		} else
			anc.ASTInsertWhyNot(_ch, _t, this);
	}

    public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	    rhs = rhs.ASTweakeningOnLeaf(_ch,exp);
	    return this;
    }

    public void typecheck( Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep ) throws Exception
    {
		this.eg = eg;

		this.inferUses(chs,ed,ep);

		ASTType ty = ed.find(chs);

	ty = ty.unfoldType(ep);

	// System.out.println("UF TC");
	
	if (ty instanceof ASTRecvTT) {
	    
		ASTRecvTT tys = (ASTRecvTT)ty;
		
		ASTType gs = new ASTIdT(ASTType.gensym());

		// System.out.println("\nTC RECVTy Type "+tys.getid());
		// System.out.println("TC RECVTy Proc "+tyid);
		// System.out.println("RECVTY GENSYM ="+((ASTIdT)gs).getid());

		EnvEntry gse = new TypeEntry (gs);
		
		Env<EnvEntry> epn = ep.assoc(((ASTIdT)gs).getid(), gse);
		
		// "0" -> "0"
		epn = epn.assoc(tyid, gse); // type parameter of process
		epn = epn.assoc(tys.getid(), gse); // type parameter of type
		tyidGen = ((ASTIdT)gs).getid();
		// epn.crawl();

		ASTType tcont = tys.getrhs().unfoldType(epn);
		ed.upd(chs,tcont);
		rhs.typecheck(ed,eg,epn);
		rhs.linclose(ed,epn);
     	    } else throw new TypeError("RECVT: "+chs+" is not of RECVT type.");
    }

	public Set<String> fn(Set<String> s) {
		s.add(chs);
		s = rhs.fn(s);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s.add(chs);
		s = rhs.fnLinear(s);
		return s;
	}

    public ASTNode subst(Env<ASTType> e) {    
	    String ns = ASTType.gensym();
	    e = e.assoc(tyid,new ASTIdT(ns));
	    ASTRecvTy p = new ASTRecvTy(chs,ns,rhs.subst(e));
	    p.rhs.setanc(p);
	    return p;
	}

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		if(y == chs)
			chs = x;

		rhs.subs(x,y);
	}

	public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
		Channel channel = (Channel) ed.find(chs);
		//		System.out.println("RECVTY ***"+chs+" "+channel.getId());
		ASTType recvType = (ASTType) channel.receive();
		//		System.out.println("RECVDTY ****"+recvType.toStr(ep)+ " on "+chs+" "+channel.getId());
		ASTTypeDef typedef = new ASTTypeDef(tyidGen);
		typedef.setType(recvType);
		logger.info("RECV TYPE "+ recvType.toStr(ep) + " on session " + channel.getId());
		rhs.runproc(ep.assoc(tyidGen, new TypeDefEntry(typedef)), ed, eg, logger);
	}
}
