import java.util.*;
import java.util.logging.*;

public class ASTSelect extends ASTNode {

    String ch;
    String lab;
    ASTNode rhs;

    public ASTSelect(String _ch, String _lab, ASTNode _rhs) {
	ch = _ch;
	lab = _lab;
	rhs = _rhs;

    }

	public  void ASTInsertUse(String _ch, ASTNode here, Boolean disCont) throws Exception
	{
		if(_ch.equals(ch)) {
			ASTNode pushUse = new ASTUse(_ch, here);
			pushUse.eg = eg;
			here.setanc(pushUse);
			pushUse.setanc(this);
			rhs = pushUse;
		}else
			anc.ASTInsertUse(_ch, this, disCont);
	}

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
		ASTNode pushCall = new ASTCall(ch, cho, t,here);
		pushCall.eg = eg;
		here.setanc(pushCall);
		pushCall.setanc(this);
		rhs = pushCall;
	}

	public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
	{
		if(_ch.equals(ch)) {
			ASTNode pushWhy = new ASTWhy(_ch, here);
			here.setanc(pushWhy);
			pushWhy.setanc(this);
			rhs = pushWhy;
			eg.insert(_ch, _t);
		} else
			anc.ASTInsertWhyNot(_ch, _t, this);
	}

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		rhs = newCont;
	}

     public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	    rhs = rhs.ASTweakeningOnLeaf(_ch,exp);
	    return this;
    }
    
   public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
		this.eg = eg;

		this.inferUses(ch,ed,ep);

		ASTType ty = ed.find(ch);

	ty = ty.unfoldType(ep);

	    ty = ASTType.unfoldRec(ty);

	    if (ty instanceof ASTCaseT) {

		ASTCaseT tyr = (ASTCaseT)ty;
		ASTType tcase = tyr.cases.get(lab);
		if(tcase==null) { throw new TypeError("case: "+lab+" is not a valid label.");}
 		ed.upd(ch,tcase);
		rhs.typecheck(ed,eg,ep);
		rhs.linclose(ed,ep);
	    } else throw new TypeError("case: "+ch+" is not of CASE type: found: "+ty.toStr(ep));
    }

	public Set<String> fn(Set<String> s) {
		s.add(ch);
		s = rhs.fn(s);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s.add(ch);
		s = rhs.fnLinear(s);
		return s;
	}

        public ASTNode subst(Env<ASTType> e) {
		ASTSelect p = new ASTSelect(ch,lab,rhs.subst(e));
		p.rhs.setanc(p);
		return p;
	}

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		if(y == ch)
			ch = x;

		rhs.subs(x,y);
	}

	public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
		Channel channel = (Channel) ed.find(ch);
		//	System.out.println("[RUNSTATUS] Start OFFER on session "+ session.id);
		channel.send(lab);
		logger.info("CHOICE " + lab + " on session " + channel.getId());
		//	System.out.println("[RUNSTATUS] Finish OFFER on session "+ session.id);
		rhs.runproc(ep, ed, eg, logger);
	}
  
}
