import java.util.*;
import java.util.logging.*;


 
public class ASTSend extends ASTNode {
    String chs;
    String cho;
    ASTType type;
    ASTNode lhs;
    ASTNode rhs;

    public ASTSend(String _chs,String _cho,ASTType _type,ASTNode _lhs,ASTNode _rhs) {
	chs = _chs;
	cho = _cho;
	type = _type;
	lhs = _lhs;
	rhs = _rhs;
    }


	public void ASTInsertUse(String _ch, ASTNode here, Boolean disCont) throws Exception
	{
		if(_ch.equals(chs) && rhs == here) {
			ASTNode pushUse = new ASTUse(_ch, here);
			pushUse.eg = eg;
			here.setanc(pushUse);
			pushUse.setanc(this);
			rhs = pushUse;
		} else if(_ch.equals(cho) && lhs == here) {
			ASTNode pushUse = new ASTUse(_ch, here);
			pushUse.eg = eg;
			here.setanc(pushUse);
			pushUse.setanc(this);
			lhs = pushUse;
		}
		else
			anc.ASTInsertUse(_ch, this, disCont);
	}

	public  void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception
	{
		ASTNode pushCall = new ASTCall(ch, cho, t, here);
		pushCall.eg = eg;

		here.setanc(pushCall);
		pushCall.setanc(this);
		if (lhs==here) lhs = pushCall;
		else rhs = pushCall;
	}

    public ASTNode ASTweakeningOnLeaf(String ch, boolean exp) throws Exception
    {
	    Set<String> s = lhs.fn(new HashSet<String>());
	    if ( !ch.equals(cho) && s.contains(ch)  ) {
		lhs = lhs.ASTweakeningOnLeaf(ch,exp);
		return this;
	    };
	    rhs = rhs.ASTweakeningOnLeaf(ch,exp);
	    return this;
    }

	public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
	{
		if(_ch.equals(chs) && rhs == here) {
			ASTNode pushWhy = new ASTWhy(_ch, here);
			pushWhy.eg = eg;
			here.setanc(pushWhy);
			pushWhy.setanc(this);
			eg.insert(_ch, _t);
			rhs = pushWhy;			
		} else if(_ch.equals(cho) && lhs == here) {
			ASTNode pushWhy = new ASTWhy(_ch, here);
			pushWhy.eg = eg;
			here.setanc(pushWhy);
			pushWhy.setanc(this);
			eg.insert(_ch, _t);
			lhs = pushWhy;			
		}
		else
			anc.ASTInsertWhyNot(_ch, _t, this);
	}				;

    /* this is BUGGY, because it cross confuses comimg from lhs and rhs */
    
    	public void XASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
	{
		if(_ch.equals(chs) || _ch.equals(cho)) {
			ASTNode pushWhy = new ASTWhy(_ch, here);
			here.setanc(pushWhy);
			pushWhy.setanc(this);
			eg.insert(_ch, _t);
			if(lhs == here)
				lhs = pushWhy;
			else
				rhs = pushWhy;
		} else
			anc.ASTInsertWhyNot(_ch, _t, this);
	}

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		if(caller == lhs)
			lhs = newCont;
		else
			rhs = newCont;
	}


	public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
	   this.eg = eg;

	   this.inferUses(chs,ed,ep);
	ASTType typee = null;
	ASTType ty = ed.find(chs);
	ty = ty.unfoldType(ep);
	ty = ASTType.unfoldRec(ty);
	if (type != null) {	
	    typee = (type!=null)?type.unfoldType(ep):type;
	    typee = ASTType.unfoldRec(typee);
        };
	if (ty instanceof ASTSendT) {
		ASTSendT tys = (ASTSendT)ty;
		ASTType tys_lhs = tys.getlhs().unfoldType(ep);
		tys_lhs = ASTType.unfoldRec(tys_lhs);
		ed.upd(chs,null);
		Env<ASTType> el = ed.assoc(cho, tys_lhs);
	       	if(typee != null && !typee.equalst(tys_lhs,ep,true,new Trail()))
		    throw new TypeError("SEND "+cho
					+" type mismatch: found="+tys_lhs.toStr(ep)+" declared="+typee.toStr(ep));

	    if(lhs instanceof ASTExpr) {
			ASTExpr pe = (ASTExpr)lhs;
			try{
				lhs = compileExpr(cho,pe,tys_lhs,ep);
			}catch (Exception e){
				if(pe instanceof ASTVId){						//expressio
					String choo = ((ASTVId) pe).ch;
					try { //check if the free output is of a linear or unrestricted name
						ed.find(choo);
						lhs = new ASTFwd(cho, choo);
					} catch (Exception ex){
						lhs = new ASTFwdB(cho,choo);
					}
				} else
					throw new TypeError("SEND " + chs + ": cannot be parsed as send of basic expression nor as free output.");
			}
			lhs.setanc(this);
		}
	    
		ep = ASTNode.propagateRVar(ep, chs, cho);

		Env<ASTType> eglhs = eg.assoc("$DUMMY",new ASTBotT());

		lhs.typecheck(el,eglhs,ep);
		lhs.linclose(el,ep);
		
		lhs = ASTInferLinClose(lhs,cho,el,ep);
				
		ed.upd(chs,tys.getrhs().unfoldType(ep));

		Env<ASTType> egrhs = eg.assoc("$DUMMY",new ASTBotT());

		rhs.typecheck(ed,egrhs,ep);
		rhs.linclose(ed,ep);
	}
	else throw new TypeError("SEND: "+chs+" is not of SEND type, fonud: "+ty.toStr(ep));
    }

	public Set<String> fn(Set<String> s) {
		s.add(chs);
		s = lhs.fn(s);
		s.remove(cho);
		s = rhs.fn(s);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s.add(chs);
		s = lhs.fnLinear(s);
		s.remove(cho);
		s = rhs.fnLinear(s);
		return s;
	}

        public ASTNode subst(Env<ASTType> e) {
	ASTSend p;
	      	if (type == null)
		    p= new ASTSend(chs, cho, type, lhs.subst(e), rhs.subst(e));
		else
		    p= new ASTSend(chs, cho, type.subst(e), lhs.subst(e), rhs.subst(e));
 	p.lhs.setanc(p);
	p.rhs.setanc(p);
	return p;
      	}

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		if(y == chs) {
			chs = x;
			rhs.subs(x,y);
		}
		else if(x == cho){//we rename the bound name chi to fresh to avoid capturing name x
			String fresh = ASTNode.gensym();
			lhs.subs(fresh, cho);
			cho = fresh;
			lhs.subs(x,y);
			rhs.subs(x,y);
		}
		else if(y != cho) {
			lhs.subs(x,y);
			rhs.subs(x, y);
		}
		else
			rhs.subs(x,y);
	}

	public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
		Channel channel = (Channel) ed.find(chs);
		LinSession sessionOut = new LinSession(cho);

		

		channel.send(sessionOut);

		logger.info("SEND-RECV on session " + channel.getId());
		//System.out.println("[RunStatus] SEND on "+session.id+" end.");

		CLLSj.threadPool.submit(
				new Runnable(){public void run(){
					try{
						lhs.runproc(ep,ed.assoc(cho, sessionOut), eg, logger);
					}catch (Exception e){ e.printStackTrace(System.out); }
				}});

			rhs.runproc(ep, ed, eg, logger);

			// CLLSj.threadPool.submit(
			//		new Runnable(){public void run(){
			//			try{
			//				rhs.runproc(ep, ed, eg);
			//			}catch (Exception e){ e.printStackTrace(System.out); }
			//		}});

	}

        	public void show()  {
	    System.out.println(this+" "+anc);
	    rhs.show();
	}

}
