import java.util.*;
import java.util.logging.*;

public class ASTSendTy extends ASTNode {
    String chs;
    ASTType type;
    ASTNode rhs;

        public ASTSendTy(String _chs,ASTType _type,ASTNode _rhs) {
	chs = _chs;
	type = _type;
	rhs = _rhs;
    }

	public  void ASTInsertUse(String _ch, ASTNode here, Boolean disCont) throws Exception
	{
		if(_ch.equals(chs)) {
			ASTNode pushUse = new ASTUse(_ch, here);
			pushUse.eg = eg;
			here.setanc(pushUse);
			pushUse.setanc(this);
			rhs = pushUse;
		}else
			anc.ASTInsertUse(_ch, this, disCont);
	}

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
		ASTNode pushCall = new ASTCall(ch, cho, t,here);
		pushCall.eg = eg;
		here.setanc(pushCall);
		pushCall.setanc(this);
		rhs = pushCall;
	}

    public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	    rhs = rhs.ASTweakeningOnLeaf(_ch,exp);
	    return this;
    }

	public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
	{
		if(_ch.equals(chs)) {
			ASTNode pushWhy = new ASTWhy(_ch, here);
			here.setanc(pushWhy);
			pushWhy.setanc(this);
			rhs = pushWhy;
			eg.insert(_ch, _t);
		} else
			anc.ASTInsertWhyNot(_ch, _t, this);
	}

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		rhs = newCont;
	}

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
		this.eg = eg;

		this.inferUses(chs,ed,ep);

		ASTType ty = ed.find(chs);
	ty = ty.unfoldType(ep);
	type = type.unfoldType(ep);
	if (ty instanceof ASTSendTT) {
		ASTSendTT tys = (ASTSendTT)ty;		
		type.kindcheck(ep);
		
		Env<ASTType> ee = new Env<ASTType>().assoc(tys.getid(),type);
		
		ed.upd(chs,tys.getrhs().unfoldType(ep).subst(ee));
		rhs.typecheck(ed,eg,ep);
		rhs.linclose(ed,ep);
     	    } else throw new TypeError("SENDT: "+chs+" is not of SENDT type.");
    }

	public Set<String> fn(Set<String> s) {
		s.add(chs);
		s = rhs.fn(s);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s.add(chs);
		s = rhs.fnLinear(s);
		return s;
	}


    public ASTNode subst(Env<ASTType> e) {
	    ASTSendTy p = new ASTSendTy(chs,type.subst(e),rhs.subst(e));
	    p.rhs.setanc(p);
	    return p;
    }

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		if(y == chs)
			chs = x;

		rhs.subs(x,y);
	}

	public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
		Channel channel = (Channel) ed.find(chs);
		ASTType typeSend = type.unfoldType(ep);
		//		System.out.println("SENDING TYPE : " + typeSend.toStr(ep) + " on session " + chs + " "+ channel.getId());
		channel.send(typeSend);
		//		System.out.println("SENT TYPE : " + typeSend.toStr(ep) + " on session " + channel.getId());
		logger.info("SENDING TYPE "+ typeSend.toStr(ep) + " on session " + channel.getId());
		//System.out.println("[RunStatus] CLOSE on "+session.id+" end.");
		rhs.runproc(ep, ed, eg, logger);
	}
}
