import java.util.*;

public abstract class ASTType {

    public abstract boolean equalst(ASTType t, Env<EnvEntry> e, boolean lit, Trail trail) throws Exception ; 

    public  abstract ASTType dual(Env<EnvEntry> e) throws Exception;

    public abstract ASTType unfoldType(Env<EnvEntry> e) throws Exception;

    public abstract void kindcheck(Env<EnvEntry> e) throws Exception;

    public abstract String toStr(Env<EnvEntry> e) throws Exception;

    public abstract ASTType subst(Env<ASTType> e); 

    public  boolean equals(Object t0) {
	boolean rb = false;
	if (!(t0 instanceof ASTType)) return false;
	ASTType t = (ASTType)t0;
	try {
	    rb = this.equalst(t,null,false,null);
	} catch (Exception _e) {
	    System.out.println("ABORT EQUALS T");
	    _e.printStackTrace(System.out);
	    System.exit(0);
	}
	return rb;
	
    }

    static private int n = 0;
    static String gensym() {
	String s = "$"+(n++);
	return s;
    }

    static ASTType unfoldRec(ASTType t) {
	if (t instanceof ASTRecT) {
	    ASTRecT t0 = (ASTRecT)t;
	    return unfoldRec(t0.getin());
	} else
	    if (t instanceof ASTCoRecT) {
	    ASTCoRecT t0 = (ASTCoRecT)t;
	    return unfoldRec(t0.getin());
	    } else return t;
    }

}
