import java.util.*;
import java.util.logging.*;

// unfolded

public class ASTUnfold extends ASTNode{
    String ch;
    ASTNode rhs;


    public ASTUnfold(String _ch, ASTNode _rhs) {
	ch = _ch;
	rhs = _rhs;
	}

	public  void ASTInsertUse(String _ch, ASTNode here, Boolean disCont) throws Exception
	{
		if(_ch.equals(ch)) {
			ASTNode pushUse = new ASTUse(_ch, here);
			pushUse.eg = eg;
			here.setanc(pushUse);
			pushUse.setanc(this);
			rhs = pushUse;
		}else
			anc.ASTInsertUse(_ch, this, disCont);
	}

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
		ASTNode pushCall = new ASTCall(ch, cho, t,here);
		pushCall.eg = eg;
		here.setanc(pushCall);
		pushCall.setanc(this);
		rhs = pushCall;
	}
    
    public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	    rhs = rhs.ASTweakeningOnLeaf(_ch,exp);
	    return this;
    }

	public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
	{
		if(_ch.equals(ch)) {
			ASTNode pushWhy = new ASTWhy(_ch, here);
			here.setanc(pushWhy);
			pushWhy.setanc(this);
			rhs = pushWhy;
			eg.insert(_ch,_t);
		} else
			anc.ASTInsertWhyNot(_ch, _t, this);
	}

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		rhs = newCont;
	}

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
		this.eg = eg;

		ASTType ty = ed.find(ch);
		ty = ty.unfoldType(ep);
		if(ty instanceof ASTCoAffineT){
			ASTCoAffineT tyco = (ASTCoAffineT)ty;
			ed.upd(ch, tyco.getin());

			ASTType cont = tyco.getin().unfoldType(ep);
			cont = ASTType.unfoldRec(cont);
			Boolean disposableCont = (cont instanceof ASTUsageT) || (cont instanceof ASTCoAffineT)
					|| (cont instanceof ASTWhyT);

			this.getanc().ASTInsertUse(ch,this, disposableCont);
			this.typecheck(ed,eg,ep);
		}
	    if (ty instanceof ASTRecT)  {
	       	ed.upd(ch,((ASTRecT)ty).getin()); 
		rhs.typecheck(ed,eg,ep);
	    } else if (ty instanceof ASTCoRecT)  {
	       	ed.upd(ch,((ASTCoRecT)ty).getin()); 
		rhs.typecheck(ed,eg,ep);
	    } else throw new TypeError("UNFOLD: "+ch+" is not of REC or COREC type.");
    }

	public Set<String> fn(Set<String> s) {
		s.add(ch);
		s = rhs.fn(s);
		return s;
	}

	public Set<String> fnLinear(Set<String> s) {
		s.add(ch);
		s = rhs.fnLinear(s);
		return s;
	}

        public ASTNode subst(Env<ASTType> e) {	    
	    ASTUnfold p =  new ASTUnfold(ch,rhs.subst(e));
	    p.rhs.setanc(p);
	    return p;
	}

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		if(y == ch)
			ch = x;
		else
			rhs.subs(x,y);
	}

	public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
		//CLLSj.logger.info("COCLOSE starts.");
		//Channel channel = (Channel) ed.find(ch);
		//CLLSj.logger.info("COCLOSE: found channel. ");
		//System.out.println("[RunStatus] WAIT on "+ch+" start.");
		//channel.receive();
		//CLLSj.logger.info("COCLOSE: took message.");
		//System.out.println("[RunStatus] WAIT on "+session.id+" end.");
		//se.remove(ch);
		rhs.runproc(ep, ed, eg, logger);
	}


}
