import java.util.*;
import java.util.logging.*;

public class ASTUse extends ASTNode {
    String ch;
    ASTNode rhs;

    public ASTUse (String _ch,ASTNode _rhs) {
        ch = _ch;
        rhs = _rhs;
    }

    public void show() {
	System.out.println(this);
	rhs.show();
    }

    public  void ASTInsertUse(String _ch, ASTNode here, Boolean disCont) throws Exception
    {
        if(_ch.equals(ch)) {
            ASTNode pushUse = new ASTUse(_ch, here);
            pushUse.eg = eg;
            here.setanc(pushUse);
            pushUse.setanc(this);
            rhs = pushUse;
        }else
            anc.ASTInsertUse(_ch, this, disCont);
    }

    public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
        ASTNode pushCall = new ASTCall(ch, cho, t,here);
        pushCall.eg = eg;
        here.setanc(pushCall);
        pushCall.setanc(this);
        rhs = pushCall;
    }

    public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
    {
        if(_ch.equals(ch)) {
            ASTNode pushWhy = new ASTWhy(_ch, here);
            pushWhy.eg = eg;
            here.setanc(pushWhy);
            pushWhy.setanc(this);
            rhs = pushWhy;
            eg.insert(_ch,_t);
        } else
            anc.ASTInsertWhyNot(_ch, _t, this);
    }

    public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
        rhs = newCont;
    }

    public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	    rhs = rhs.ASTweakeningOnLeaf(_ch,exp);
	    return this;
    }

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
        this.eg = eg;

        ASTType ty = ed.find(ch);
       ty = ty.unfoldType(ep);
 	ty = ASTType.unfoldRec(ty);
        if (ty instanceof ASTCoAffineT) {
            ASTCoAffineT tyr = (ASTCoAffineT)ty;
            ed.upd(ch, tyr.getin().unfoldType(ep));
            rhs.typecheck(ed,eg,ep);
            rhs.linclose(ed,ep);
        }
        else throw new TypeError("USE: "+ch+" is not of COAFFINE type.");
    }

    public Set<String> fn(Set<String> s) {
        s = rhs.fn(s);
        s.add(ch);
        return s;
    }

    public Set<String> fnLinear(Set<String> s) {
        s = rhs.fnLinear(s);
        s.add(ch);
        return s;
    }

    public ASTNode subst(Env<ASTType> e) {
	    ASTUse p = new ASTUse(ch,rhs.subst(e));
        p.rhs.setanc(p);
        return p;
	}

    public void subs(String x, String y){// implements x/y (substitutes y by x)
        if(y == ch)
            ch = x;

        rhs.subs(x,y);
    }
    public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
        Channel channel = (Channel) ed.find(ch);
        channel.send("USE");
        logger.info("USE session " + channel.getId());
        rhs.runproc(ep, ed, eg, logger);
    }

    public String toStr(Env<EnvEntry> ep) throws Exception {
        return "use " + ch + ";\n" + rhs.toStr(ep);
    }

}
