import java.util.*;

public class ASTVId extends ASTExpr {

    String ch;

    boolean linId;

    public ASTVId(String _ch) {
	ch = _ch;
    }

    public  void editASTInsertUse(String ch, ASTNode here, Boolean disCont)
    {
	// never called
    }

    public void ASTInsertWhyNot(String _ch, ASTType _t, ASTNode here) throws Exception
    {
        throw new Exception ("Unexpected call: ASTInsertWhyNot"); // never called
    }

    public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
        throw new Exception ("Unexpected call.");
    }

    public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
        throw new Exception ("Unexpected call: ASTInsertCall"); // never called
    }

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
    }

    public Set<String> fn(Set<String> s) {
	s.add(ch);
        return s;
    }

    public Set<String> fnLinear(Set<String> s) {
        return s;
    }

            public ASTNode subst(Env<ASTType> e) {
	    return this;
	}

    public void subs(String x, String y){// implements x/y (substitutes y by x)
        if(ch == y)
            ch = x;
    }
    public ASTType etypecheck(Env<ASTType> ed,  Env<ASTType> eg,Env<EnvEntry> ep, boolean lin) throws Exception {
	ASTType ty;
	try{
	    ty = ed.find(ch);
	    ty = ty.unfoldType(ep);
	    ty = ASTType.unfoldRec(ty);
        if(ty instanceof ASTWhyT){
            ASTWhyT t = (ASTWhyT) ty;
            ty= t.getin();
            this.getanc().ASTInsertWhyNot(ch, ty, this);
            ed.updmove(ch);
            return this.etypecheck(ed,eg,ep, lin);
        }

        if (ty instanceof ASTCoAffineT){
            // System.out.println("DEBUG infferign use for " + ch);
            ASTCoAffineT tyco = (ASTCoAffineT)ty;
            ed.upd(ch, tyco.getin());

            ASTType cont = tyco.getin().unfoldType(ep);
            cont = ASTType.unfoldRec(cont);
            Boolean disposableCont = (cont instanceof ASTUsageT) || (cont instanceof ASTCoAffineT)
                    || (cont instanceof ASTWhyT);

            this.getanc().ASTInsertUse(ch,this, disposableCont);
            return this.etypecheck(ed,eg,ep,lin);
        }
        linId = true;
    } catch (Exception e){
	    //e.printStackTrace(System.out);
	    ty = eg.find(ch);
        ty = ty.unfoldType(ep);
        ty = ASTType.unfoldRec(ty);
        if(!(ty instanceof ASTCoLBasicType)){
	        String cho = ASTType.gensym();
	        this.getanc().ASTInsertCall(ch,cho,ty,this);
	        ed = ed.assoc(cho,ty);
	        this.ch = cho;
	        return this.etypecheck(ed,eg,ep,lin);
        }
	    linId = false;
    }

    if(!lin && linId)
        throw new TypeError("Expression id " + ch + " must be unrestricted." );

    if(ty instanceof ASTCoLBasicType) {
        if(linId)
            ed.upd(ch,null);
        return ty;
    } else throw new TypeError("Expression id: "+ch+" is not of CoLBasicType. Type = " + ty.toStr(null));
    }

    public Value eval(Env<LinSession> ed, Env<Server> eg) throws Exception{
        Value v;
        if(linId){
            Channel channel = (Channel) ed.find(ch);
            v = (Value) channel.receive();
            return v;
        } else {
            Server server = eg.find(ch);
            if(server instanceof Value) {
                v = (Value) server;
                return v;
            }else {
                Channel channel = (Channel) server.call(ch);
                v = (Value) channel.receive();
                return v;
            }
        }
    }

}
