import java.util.*;
import java.util.logging.*;

public class ASTWhy extends ASTNode {
    String ch;
    ASTNode rhs;


    public ASTWhy(String _ch, ASTNode _rhs) {
	ch = _ch;
	rhs = _rhs;
    }

	public  void ASTInsertUse(String _ch, ASTNode here, Boolean disCont) throws Exception
	{
		anc.ASTInsertUse(_ch,this,disCont);
	}

	public void ASTInsertCall(String ch, String cho, ASTType t, ASTNode here) throws Exception{
		ASTNode pushCall = new ASTCall(ch, cho, t,here);
		pushCall.eg = eg;
		here.setanc(pushCall);
		pushCall.setanc(this);
		rhs = pushCall;
	}

	public void ASTInsertWhyNot(String ch, ASTType _t, ASTNode here) throws Exception
	{
		anc.ASTInsertWhyNot(ch, _t, this);
	}
    
    public ASTNode ASTweakeningOnLeaf(String _ch, boolean exp) throws Exception
    {
	    rhs = rhs.ASTweakeningOnLeaf(_ch,exp);
	    return this;
    }

	public void ASTupdCont(ASTNode newCont, ASTNode caller) throws Exception{
		rhs = newCont;
	}

    public void typecheck(Env<ASTType> ed, Env<ASTType> eg, Env<EnvEntry> ep) throws Exception {
    	this.eg = eg;
		this.inferUses(ch,ed,ep);
		ASTType ty = ed.find(ch);
	    ty = ty.unfoldType(ep);
	    if (ty instanceof ASTWhyT) {
		ASTWhyT tyr = (ASTWhyT)ty;
		ed.upd(ch,null);
		eg=eg.assoc(ch, tyr.getin().unfoldType(ep));
		rhs.typecheck(ed,eg,ep);
	    } else if (ty instanceof ASTCoBasicType) {
	      	ASTCoBasicType tyr = (ASTCoBasicType)ty;
		ed.upd(ch,null);
		eg=eg.assoc(ch, tyr.lift());
		rhs.typecheck(ed,eg,ep);
	    }
	    else throw new TypeError("?: "+ch+" is neither of ? or basic co-type.");
    }

    public Set<String> fn(Set<String> s) {
        s.add(ch);
        s = rhs.fn(s);
	return s;
    }

	public Set<String> fnLinear(Set<String> s) {
		s.add(ch);
		s = rhs.fnLinear(s);
		return s;
	}

    public ASTNode subst(Env<ASTType> e) {
	 ASTWhy p = new ASTWhy(ch,rhs.subst(e));
	 p.rhs.setanc(p);
	 return p;
    }

	public void subs(String x, String y){// implements x/y (substitutes y by x)
		if(y == ch)
			ch = x;

		rhs.subs(x,y);
	}

	public void runproc(Env<EnvEntry> ep, Env<LinSession> ed, Env<Server> eg, Logger logger) throws Exception{
		Channel channel = (Channel) ed.find(ch);
		Server server = (Server) channel.receive();
		logger.info("Server activated on session " + channel.getId());
		rhs.runproc(ep, ed, eg.assoc(ch,server), logger);
	}

}
